import hashlib
import sys

def get_file_hash(file_path):
    with open(file_path, 'rb') as f:
        file_hash = hashlib.sha256(f.read()).hexdigest()
    return file_hash


def check_hash():
    try:
        with open('bf.v', 'r') as hash_file:
            original_hash = hash_file.read().strip()
    except FileNotFoundError:
        print(" ")
        sys.exit(1)

    current_hash = get_file_hash('Black_Beard.py')

    if current_hash != original_hash:
        print("Connection lost")
        sys.exit(1)  
check_hash()

import os
import pyzipper
import rarfile
import py7zr
import pikepdf
import time
from tqdm import tqdm
import signal

GREEN = '\033[92m'
RED = '\033[91m'
CYAN = '\033[96m'
YELLOW = '\033[93m'
RESET = '\033[0m'

def type_effect(text, delay=0.05):
    for char in text:
        print(char, end='', flush=True)
        time.sleep(delay)
    print()

def show_welcome_message():
    message = f"{CYAN}★ Welcome to Crack Passwords Tool \n\n[✓] Crack Zip \n[✓] Crack RAR \n[✓] Crack Pdf \n[✓] Crack Docx \n[✓] Crack 7z \n\n★ Made By Black Beard {YELLOW}@Ilzci{RESET}"
    type_effect(message, delay=0.05)

def draw_green_box(message):
    border = f"{GREEN}{'═' * (len(message) + 4)}{RESET}"
    return f"{GREEN}╔{border}╗\n║  {message}  ║\n╚{border}╝{RESET}"

def draw_red_box(message):
    border = f"{RED}{'═' * (len(message) + 4)}{RESET}"
    return f"{RED}╔{border}╗\n║  {message}  ║\n╚{border}╝{RESET}"


def try_crack_zip(zip_file, password):
    try:
        with pyzipper.AESZipFile(zip_file) as zf:
            zf.extractall(pwd=password.encode('utf-8'))
        return True
    except:
        return False

def try_crack_rar(rar_file, password):
    try:
        with rarfile.RarFile(rar_file) as rf:
            rf.extractall(password=password)
        return True
    except:
        return False

def try_crack_pdf(pdf_file, password):
    try:
        with pikepdf.open(pdf_file, password=password):
            return True
    except pikepdf.PasswordError:
        return False
    except Exception as e:
        print(f"Error while processing {pdf_file}: {str(e)}")
        return False

def try_crack_docx(docx_file, password):
    try:
        from docx import Document
        document = Document(docx_file)
        return True
    except:
        return False

def try_crack_7z(seven_zip_file, password):
    try:
        with py7zr.SevenZipFile(seven_zip_file, mode='r') as archive:
            archive.extractall(password=password)
        return True
    except:
        return False

def crack_all_zips_in_folder(folder_path, wordlist_path):
    found_passwords = {}

    files = [f for f in os.listdir(folder_path) if f.lower().endswith(('.zip', '.rar', '.pdf', '.docx', '.7z'))]
    if not files:
        print(f"{RED}[!] No files found in folder. Please add files to crack.{RESET}")
        return

    for filename in files:
        zip_path = os.path.join(folder_path, filename)

        print(f"\n========= Checking: {filename} =========")

        password = None
        tried_count = 0
        found = False

        with open(wordlist_path, 'r') as f:
            wordlist = f.readlines()

        total = len(wordlist)
        progress_bar = tqdm(total=total, unit="word", dynamic_ncols=True)

        for line in wordlist:
            password = line.strip()
            tried_count += 1

            percent = (tried_count / total) * 100
            if percent < 40:
                color = YELLOW
            elif percent < 80:
                color = CYAN
            else:
                color = GREEN

            progress_bar.set_description(f"{color}Cracking {filename}{RESET}")
            progress_bar.update(1)

            if filename.lower().endswith('.zip'):
                if try_crack_zip(zip_path, password):
                    found_passwords[filename] = password
                    found = True
                    print(f"{GREEN}[✓] Password found for {filename}: {password}{RESET}")
                    break
            elif filename.lower().endswith('.rar'):
                if try_crack_rar(zip_path, password):
                    found_passwords[filename] = password
                    found = True
                    print(f"{GREEN}[✓] Password found for {filename}: {password}{RESET}")
                    break
            elif filename.lower().endswith('.pdf'):
                if try_crack_pdf(zip_path, password):
                    found_passwords[filename] = password
                    found = True
                    print(f"{GREEN}[✓] Password found for {filename}: {password}{RESET}")
                    break
            elif filename.lower().endswith('.docx'):
                if try_crack_docx(zip_path, password):
                    found_passwords[filename] = password
                    found = True
                    print(f"{GREEN}[✓] Password found for {filename}: {password}{RESET}")
                    break
            elif filename.lower().endswith('.7z'):
                if try_crack_7z(zip_path, password):
                    found_passwords[filename] = password
                    found = True
                    print(f"{GREEN}[✓] Password found for {filename}: {password}{RESET}")
                    break

        progress_bar.close()
        if not found:
            print(draw_red_box(f"{RED}[-] No password found for: {filename}{RESET}"))

    if found_passwords:
        for fname, pwd in found_passwords.items():
            msg = f"{fname}   ➡︎ {GREEN}{pwd}{RESET}"
            print(draw_green_box(msg))

        with open("found_passwords.txt", "w") as f:
            for fname, pwd in found_passwords.items():
                f.write(f"{fname}   ➡︎ {pwd}\n")
        print("\n[✓] Passwords saved to found_passwords.txt")
    else:
        print(draw_red_box(f"{RED}[-] No passwords found for any file.{RESET}"))

def handle_exit(signum, frame):
    print("\n{RED}The tool has been Pause .")
    choice = input("\n [1] Restart \n [2] Resume \n [3] Exit \n Enter your choice: ")
    if choice == "1":
        print("\nRestarting the tool...\n")
        main()
    elif choice == "2":
        print("\n ")
        sys.exit(0)
    else:
        print("\nInvalid choice. Exiting now.")
        sys.exit(0)

signal.signal(signal.SIGINT, handle_exit)

def main():
    show_welcome_message()
    zip_folder = "zips"
    wordlist = "wordlist.txt"
    crack_all_zips_in_folder(zip_folder, wordlist)

if __name__ == "__main__":
    main()