# core/crack_zip.py
import pyzipper
from utils import constants

GREEN = '\033[92m'
RED = '\033[91m'
YELLOW = '\033[93m'
CYAN = '\033[96m'
BLUE = '\033[94m'
RESET = '\033[0m'

class BaseCrack(object):
    def __init__(self, zip_file, max_length=constants.DEFAULT_MAX_LENGTH, min_length=constants.DEFAULT_MIN_LENGTH):
        self._max_length = max_length
        self._min_length = min_length
        self._zip_file = zip_file
        
    def crack(self):
        pass
    
    def try_crack(self, curr_pswd):
        try:
            with pyzipper.AESZipFile(self._zip_file) as zf:
                zf.extractall(pwd=curr_pswd.encode('utf-8'))
        except:
            return False
        return True

class WordlistCrack(BaseCrack):
    def __init__(self, zip_file, wordlist_file):
        super().__init__(zip_file)
        self.wordlist_file = wordlist_file

    def crack(self):
        attempt = 1
        with open(self.wordlist_file, 'r', encoding='utf-8') as f:
            for line in f:
                password = line.strip()
                print(f"{YELLOW}[{BLUE}{attempt}{YELLOW}] Trying: {password}{RESET}")
                if self.try_crack(password):
                    msg = f"[+] Password found: {password}"
                    border = f"{CYAN}{'═' * (len(msg) + 4)}{RESET}"
                    print(f"\n{CYAN}╔{border}╗{RESET}")
                    print(f"{CYAN}║  {GREEN}{msg}{CYAN}  ║{RESET}")
                    print(f"{CYAN}╚{border}╝{RESET}")
                    return password
                attempt += 1
        print(f"{RED}[-] Password not found.{RESET}")
        return None